@echo off & setlocal enableextensions

:: imgslim v0.2 (05-Apr-2007) WinXP version
:: By Sined, dedicated to the Public Domain.


set VersionText=(v0.2)
set ImgDir=%~dp0
PATH %ImgDir%;%PATH% >nul
:: Check some image files have been provided
if .%1==. (
 echo Drag-and-drop a selection of image files to optimize them.
 goto theend
)
set zs=0
set TotalBytes=0
for %%i in (%*) do set /a TotalFiles+=1


:start
set /a ImgNum+=1
title [%ImgNum%/%TotalFiles%] imgslim
echo %~z1b - Optimizing: %1
set z0=%~z1
copy %1 %1.backup >nul
exiftool.exe %1
jpegtran.exe -optimize -copy all %1 %1
echo %~z1b - Jpegtran, baseline DTC encoding
exiftool.exe -q -P -overwrite_original -all= %1
echo %~z1b - Exiftool, metadata removed

if %~z1 GEQ %z0% (
 del %1
 rename "%~1.backup" "%~nx1"
 copy %1 %1.backup >nul
)
set /a zb=%z0%-%~z1
if %~z1 LSS %z0% (
 del %1.backup
 echo Optimized: "%~n1". Slimmed %zb% bytes.
 copy %1 %1.backup >nul
 set z0=%~z1
)

jpegtran.exe -optimize -progressive -copy all %1 %1
echo %~z1b - Jpegtran, progressive DTC encoding
exiftool.exe -q -P -overwrite_original -all= %1
echo %~z1b - Exiftool, metadata removed

if %~z1 GEQ %z0% (
 del %1
 rename "%~1.backup" "%~nx1"
)

set /a zs=%zb%+%z0%-%~z1
set /a TotalBytes+=%zs%

if %~z1 LSS %z0% (
 del %1.backup
 echo Optimized: "%~n1". Slimmed %zs% bytes.
)

:nextfile
echo.
shift
if .%1==. goto close
goto start


:close
title Optimization complete.
echo.
echo Finished %date% %time% - imgslim %VersionText%.
echo Processed %TotalFiles% files. Slimmed %TotalBytes% bytes.

:theend
endlocal
pause
title %ComSpec%
